# pip install --upgrade pinecone
import os
from pinecone import Pinecone
pc = Pinecone(api_key=os.environ["PINECONE_API_KEY"])
# Passing file_id creates or replaces the file with that ID
file = pc.assistants.upload_file(
assistant_name="example-assistant",
file_path="/Users/jdoe/Downloads/example_file.txt",
file_id="my-custom-file-id",
)
print(file.id, file.status)
// npm install @pinecone-database/pinecone
import { Pinecone } from '@pinecone-database/pinecone';
// Reads PINECONE_API_KEY from the environment
const pc = new Pinecone();
const assistant = pc.assistant({ name: 'example-assistant' });
const operation = await assistant.upsertFile({
assistantFileId: 'my-custom-file-id',
path: '/Users/jdoe/Downloads/example_file.txt',
});
console.log(operation);
PINECONE_API_KEY="YOUR_API_KEY"
ASSISTANT_NAME="example-assistant"
FILE_ID="my-custom-file-id"
LOCAL_FILE_PATH="/Users/jdoe/Downloads/example_file.txt"
curl -X PUT "https://prod-1-data.ke.pinecone.io/assistant/files/$ASSISTANT_NAME/$FILE_ID" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2026-07" \
-F "file=@$LOCAL_FILE_PATH"
{
"id": "op-1234-abcd-5678",
"operation_type": "upload_file",
"status": "Processing",
"created_on": "2025-10-01T12:30:00.000Z",
"file_id": "my-file-id-123",
"completed_on": "2025-10-01T12:35:00.000Z",
"percent_complete": 42,
"error_message": "File processing failed: unsupported file format.",
"ingestion_units": 50
}{
"error": {
"code": "INVALID_ARGUMENT",
"message": "Uploaded file can only currently be either a pdf or txt file"
},
"status": 400
}{
"error": {
"code": "UNAUTHENTICATED",
"message": "Invalid API key."
},
"status": 401
}{
"error": {
"code": "NOT_FOUND",
"message": "Assistant \"example-assistant\" not found."
},
"status": 404
}{
"error": {
"code": "UNKNOWN",
"message": "Internal server error"
},
"status": 500
}Upsert a file
Create or replace a file in the specified assistant. If a file with the given assistant_file_id already exists, it will be replaced with the new file. If it doesn’t exist, a new file will be created with that identifier.
This operation is asynchronous. The file processing will occur in the background.
For guidance and examples, see Manage files.
# pip install --upgrade pinecone
import os
from pinecone import Pinecone
pc = Pinecone(api_key=os.environ["PINECONE_API_KEY"])
# Passing file_id creates or replaces the file with that ID
file = pc.assistants.upload_file(
assistant_name="example-assistant",
file_path="/Users/jdoe/Downloads/example_file.txt",
file_id="my-custom-file-id",
)
print(file.id, file.status)
// npm install @pinecone-database/pinecone
import { Pinecone } from '@pinecone-database/pinecone';
// Reads PINECONE_API_KEY from the environment
const pc = new Pinecone();
const assistant = pc.assistant({ name: 'example-assistant' });
const operation = await assistant.upsertFile({
assistantFileId: 'my-custom-file-id',
path: '/Users/jdoe/Downloads/example_file.txt',
});
console.log(operation);
PINECONE_API_KEY="YOUR_API_KEY"
ASSISTANT_NAME="example-assistant"
FILE_ID="my-custom-file-id"
LOCAL_FILE_PATH="/Users/jdoe/Downloads/example_file.txt"
curl -X PUT "https://prod-1-data.ke.pinecone.io/assistant/files/$ASSISTANT_NAME/$FILE_ID" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2026-07" \
-F "file=@$LOCAL_FILE_PATH"
{
"id": "op-1234-abcd-5678",
"operation_type": "upload_file",
"status": "Processing",
"created_on": "2025-10-01T12:30:00.000Z",
"file_id": "my-file-id-123",
"completed_on": "2025-10-01T12:35:00.000Z",
"percent_complete": 42,
"error_message": "File processing failed: unsupported file format.",
"ingestion_units": 50
}{
"error": {
"code": "INVALID_ARGUMENT",
"message": "Uploaded file can only currently be either a pdf or txt file"
},
"status": 400
}{
"error": {
"code": "UNAUTHENTICATED",
"message": "Invalid API key."
},
"status": 401
}{
"error": {
"code": "NOT_FOUND",
"message": "Assistant \"example-assistant\" not found."
},
"status": 404
}{
"error": {
"code": "UNKNOWN",
"message": "Internal server error"
},
"status": 500
}# pip install --upgrade pinecone
import os
from pinecone import Pinecone
pc = Pinecone(api_key=os.environ["PINECONE_API_KEY"])
# Passing file_id creates or replaces the file with that ID
file = pc.assistants.upload_file(
assistant_name="example-assistant",
file_path="/Users/jdoe/Downloads/example_file.txt",
file_id="my-custom-file-id",
)
print(file.id, file.status)
// npm install @pinecone-database/pinecone
import { Pinecone } from '@pinecone-database/pinecone';
// Reads PINECONE_API_KEY from the environment
const pc = new Pinecone();
const assistant = pc.assistant({ name: 'example-assistant' });
const operation = await assistant.upsertFile({
assistantFileId: 'my-custom-file-id',
path: '/Users/jdoe/Downloads/example_file.txt',
});
console.log(operation);
PINECONE_API_KEY="YOUR_API_KEY"
ASSISTANT_NAME="example-assistant"
FILE_ID="my-custom-file-id"
LOCAL_FILE_PATH="/Users/jdoe/Downloads/example_file.txt"
curl -X PUT "https://prod-1-data.ke.pinecone.io/assistant/files/$ASSISTANT_NAME/$FILE_ID" \
-H "Api-Key: $PINECONE_API_KEY" \
-H "X-Pinecone-Api-Version: 2026-07" \
-F "file=@$LOCAL_FILE_PATH"
Path Parameters
Query Parameters
Body
The desired file to be uploaded and processed into the assistant.
Optional metadata associated with the file. This metadata can be used to filter files when listing them or to restrict search results when querying the assistant. Maximum size is 16KB.
{
"created_by": "Jane Doe",
"published": "2025-10-01T00:00:00.000Z",
"tags": ["report", "Q4", "analytics"]
}
Response
File upload has been accepted for processing. The file will be created if it doesn't exist, or replaced if it already exists. The operation will complete asynchronously.
Describes the status of an ongoing or completed server operation.
Was this page helpful?